package org.openxma.rwt.bridge;

import java.util.HashMap;
import java.util.Map;

import org.apache.commons.httpclient.HttpState;

import at.spardat.xma.boot.comp.AppManager;
import at.spardat.xma.boot.component.IRtXMASessionClient;
import at.spardat.xma.boot.transport.HTTPTransport;

public class RwtHttpTransport extends HTTPTransport {
	Map<AppManager, HttpState> httpStates = new HashMap<AppManager, HttpState>();
	
	public RwtHttpTransport() {
		super();
		System.out.println("RwtHttpTransport created");		
	}
	
	@Override
	protected HttpState getHttpState(IRtXMASessionClient session) {
		if (session == null) {
			return super.getHttpState(session);
		}
		HttpState state = httpStates.get(session.getAppContainer().getAppManager());
		if (state == null) {
			state = new HttpState();
			httpStates.put(session.getAppContainer().getAppManager(), state);
		}
		return state;
	}
	
}
